from Tkinter import *

class ArgumentDirectory:
    def __init__(self):
        self.filename = None

    def exists(self,object):
        """
        see if object exists
        """
        self.filename = "man/"
        self.filename = self.filename + object + ".man"
        try:
            file = open( self.filename )
        except:
            return "n"

        file.close()
        return "y"
    
    def load(self,object):
        """
        attempt to locate help file for object and display it
        """
        self.filename = "man/"
        self.filename = self.filename + object + ".man"
        try:
            file = open( self.filename )
        except:
            import tkMessageBox
            tkMessageBox.showerror(self.filename,"No argmuent help available for this widget")
            return ""

        information = file.readlines()
        file.close()

        frame = Frame(Tk(),bd=2,relief=SUNKEN,height=800,width=600)
        frame.grid_rowconfigure(0, weight=1)
        frame.grid_columnconfigure(0, weight=1)

        xscrollbar = Scrollbar(frame, orient=HORIZONTAL)
        xscrollbar.grid(row=1, column=0, sticky=E+W)

        yscrollbar = Scrollbar(frame)
        yscrollbar.grid(row=1,column=0,sticky=E+W)
        
        text = Text(frame,wrap=WORD, bd=0,
                    yscrollcommand = yscrollbar.set,
                    xscrollcommand = xscrollbar.set)
        for line in information:
            text.insert(END,line)
        text.grid(row=0, column=0,sticky=N+E+S+W)

        xscrollbar.config(command=text.xview)
        yscrollbar.config(command=text.yview)

        frame.pack()
