from JetWidget import *
from ConnectionPoint import *

class SeqWidget(JetWidget):
    """Sequencing widget, used to impose a sequence pipelines,
ie. to say "This comes first", This comes second"."""
    def __init__(self, graph, command, x = 0, y = 0, attrs = {}):
        print "BANG"
        JetWidget.__init__(self, graph, command, x, y, attrs)
        self.create_ctrlo()
    def create_ctrlo(self):
        bbox = self.graph.bbox(self.alltag)
        #Note -- self.alltag should include all the other ConnectionPoints
        # by now, so we can just use the coordinates of bbox.
        x = bbox[2] #Right edge of bbox
        y = bbox[1] #Top of bbox
        deltay = bbox[3]-bbox[1] #How much room for the widgets
        self.ctrlo = [ConnectionPoint(self, self.graph, [x, y],
                                      [x + 5, y + deltay/3], "ctrlo1",
                                      self.alltag),
                      ConnectionPoint(self, self.graph, [x, y+deltay/3],
                                      [x + 5, y + 2*deltay/3], "ctrlo2",
                                      self.alltag),
                      ConnectionPoint(self, self.graph, [x, y+2*deltay/3],
                                      [x + 5, y + deltay], "ctrlo3",
                                      self.alltag)]
    def Accept(self, visitor):
        JetWidget.Accept(self, visitor)
        
    def VisitEach(self, visitor):
        """Visit each of the nodes attached to this one."""
        needsemi = False
        for k in ["ctrlo1", "ctrlo2", "ctrlo3"]:
            if self.connectsdict.has_key(k):
                if needsemi:
                    visitor.AddSemi()
                    needsemi = False
                self.connectsdict[k].OtherWidget(self).AcceptPipeline(visitor)
                needsemi = True

